Author: 
Description: 
Index: librtf-document-perl/Document.pm
===================================================================
--- librtf-document-perl.orig/Document.pm	2015-07-21 21:55:14.839491051 +0200
+++ librtf-document-perl/Document.pm	2015-07-21 21:56:00.519375457 +0200
@@ -14,6 +14,7 @@
 @EXPORT_OK = qw();
 
 use Carp;
+use strict 'vars', 'subs';
 use POSIX qw(floor ceil);
 use Convert::Units::Type 0.33;
 
@@ -129,7 +130,7 @@
 sub _prop_style {
     my ($self, $code, $arg) = @_;
     $code = decode_stylename($arg, '\s222');
-    my $formatting, $style_properties;
+    my ($formatting, $style_properties);
 
     if (defined($code)) {
         $formatting = $self->new_group();
@@ -242,16 +243,16 @@
     'doc_rtf_def'		=> [ 'text',  'defformat',   0, \&_prop_on ],
 
     # --- Page sizes, margins, etc.
-    doc_page_width	=> [ text,  paperw,	0, \&_prop_twips ],
-    doc_page_height	=> [ text,  paperh,	0, \&_prop_twips ],
-    doc_landscape	=> [ text,  landscape,	0, \&_prop_on ],
-    doc_facing	=> [ text,  facingp,	0, \&_prop_on ],
-    doc_margin_left	=> [ text,  margl,		0,  \&_prop_twips ],
-    doc_margin_right	=> [ text,  margr,		0, \&_prop_twips ],
-    doc_margin_top	=> [ text,  margt,		0, \&_prop_twips ],
-    doc_margin_bottom => [ text,  margb, 	0, \&_prop_twips ],
-    doc_margin_mirror=> [ text,  margmirror, 	0, \&_prop_on ],
-    doc_gutter	=> [ text,  gutter, 	0, \&_prop_twips ],
+    doc_page_width	=> [ 'text',  'paperw',	0, \&_prop_twips ],
+    doc_page_height	=> [ 'text',  'paperh',	0, \&_prop_twips ],
+    doc_landscape	=> [ 'text',  'landscape',	0, \&_prop_on ],
+    doc_facing	=> [ 'text',  'facingp',	0, \&_prop_on ],
+    doc_margin_left	=> [ 'text',  'margl',		0,  \&_prop_twips ],
+    doc_margin_right	=> [ 'text',  'margr',		0, \&_prop_twips ],
+    doc_margin_top	=> [ 'text',  'margt',		0, \&_prop_twips ],
+    doc_margin_bottom => [ 'text',  'margb', 	0, \&_prop_twips ],
+    doc_margin_mirror=> [ 'text',  'margmirror', 	0, \&_prop_on ],
+    doc_gutter	=> [ 'text',  'gutter', 	0, \&_prop_twips ],
 
     # --- Hyphenation
     doc_hyphen_auto	=> [ 'text', 'hyphauto', 0,  \&_prop_onoff ],
@@ -260,10 +261,10 @@
     doc_hyphen_zone	=> [ 'text', 'hyphhotz', 0,  \&_prop_twips ],
 
     # --- Views
-    doc_view_scale	=> [ text,  viewscale,   0, \&_prop_raw  ],
-    doc_view_zoom	=> [ text, { none=>'viewzk0', 'full-page'=>'viewzk1',
+    doc_view_scale	=> [ 'text',  'viewscale',   0, \&_prop_raw  ],
+    doc_view_zoom	=> [ 'text', { none=>'viewzk0', 'full-page'=>'viewzk1',
       'best-fit'=>'viewzk1' },  0, \&_prop_decode ],
-    doc_view_caption	=> [ text, windowcaption, 1, , \&_prop_pcdata ],
+    doc_view_caption	=> [ 'text', 'windowcaption', 1, , \&_prop_pcdata ],
     'doc_view_mode'	=> [ 'text', { 'none'=>'viewkind0', 'layout'=>'viewkind1',
       'outline'=>'viewkind2', 'master'=>'viewkind3',
 
@@ -276,7 +277,7 @@
     'doc_charset'		=> [ 'charset' ],
 
     # --- Widow/orphan controls
-    doc_widow_cntrl	=> [ text,  widowctrl,   0, \&_prop_on ],
+    doc_widow_cntrl	=> [ 'text',  'widowctrl',   0, \&_prop_on ],
 
     # --- Tabs
     tabs_default	=> [ 'text',  'deftab', 	0, \&_prop_twips ],
@@ -296,14 +297,14 @@
       'page'=>'sbkpage', 'even'=>'sbkeven', 'odd'=>'sbkodd'}, 0, \&_prop_decode ],
 
     # --- Columns
-    col		=> [ text,  'colulmn',  	0, \&_prop_on ],
-    col_soft		=> [ text,  'softcol',  	0, \&_prop_on ],
-    col_num		=> [ text,  'cols',  	0, \&_prop_raw ],
-    col_space		=> [ text,  'colsx', 	0, \&_prop_twips ],
-    col_select	=> [ text,  'colno', 	0, \&_prop_raw ],
-    col_padding_right => [ text, 'colsr', 	0, \&_prop_twips ],
-    col_width 	=> [ text,  'colw',		0, \&_prop_twips ],
-    col_line		=> [ text,  'linebetcol',	0, \&_prop_on ],
+    col		=> [ 'text',  'colulmn',  	0, \&_prop_on ],
+    col_soft		=> [ 'text',  'softcol',  	0, \&_prop_on ],
+    col_num		=> [ 'text',  'cols',  	0, \&_prop_raw ],
+    col_space		=> [ 'text',  'colsx', 	0, \&_prop_twips ],
+    col_select	=> [ 'text',  'colno', 	0, \&_prop_raw ],
+    col_padding_right => [ 'text', 'colsr', 	0, \&_prop_twips ],
+    col_width 	=> [ 'text',  'colw',		0, \&_prop_twips ],
+    col_line		=> [ 'text',  'linebetcol',	0, \&_prop_on ],
 
     'page_brk'	=> [ 'text', 'page', 	0, \&_prop_on ],
     'page_softbrk'	=> [ 'text', 'softpage',	0, \&_prop_on ],
@@ -316,7 +317,7 @@
 
     # --- Alignment
     'par_align'	=> [ 'text', { left=>'ql', right=>'qr', center=>'qc', justify=>'qj' },  0, \&_prop_decode ],
-    'sec_vert_align'	=> [ 'text', { top=>vertalt, bottom=>vertalb, center=>vertalc },  0, \&_prop_decode ],
+    'sec_vert_align'	=> [ 'text', { top=>'vertalt', bottom=>'vertalb', center=>'vertalc' },  0, \&_prop_decode ],
 
     # --- Indentation
     'par_indent_first'	=> [ 'text', 'fi', 	0, \&_prop_twips ],
@@ -378,7 +379,7 @@
     'par_hyphen'		=> [ 'text', 'hyphpar', 	0,  \&_prop_onoff ],
 
     # --- Widow/orphan controls
-    'par_widow_cntrl' 	=> [ text, { 0=>nowidctlpar, 1=>widctlpar }, 0, \&_prop_decode ],
+    'par_widow_cntrl' 	=> [ 'text', { 0=>'nowidctlpar', 1=>'widctlpar' }, 0, \&_prop_decode ],
     'par_intact'		=> [ 'text', 'keep',  	0, \&_prop_on ],
     'par_keep_next'		=> [ 'text', 'keepn',	0, \&_prop_on ],
 
@@ -397,9 +398,9 @@
     my $self = shift;
 
     my $table = shift,
-       $settings = shift,
-       $destination = shift;
-    my ($property, $value, $where, $what, $arg, $default);
+    my $settings = shift,
+    my $destination = shift;
+    my ($property, $value, $where, $what, $group, $arg, $default);
 
     local ($_);
 
@@ -426,7 +427,7 @@
                 {
                     if ($group) {
                         my $subgroup = $self->add_group($where);
-                        $self->add_raw ($subroup, @controls );
+                        $self->add_raw ($subgroup, @controls );
                     } else {
                         $self->add_raw ($where, @controls );
                     }
@@ -469,7 +470,7 @@
     my $self = shift;
     $self->set_properties (\%DOCINFO, @_);
 
-    $self->splice_raw ($self->{DOCUMENT}, 1, 1, "\\".$self->{charset});
+    $self->splice_raw ($self->{DOCUMENT}, 1, 1, "\\".$self->{charset}) if ( defined $self->{charset} );
 
     # --- Insert creation time in Information Group
     if ($self->{creatim})
@@ -498,7 +499,7 @@
 }
 
 sub emit_group {
-    local ($el, $data);
+    my ($el, $data);
 
     unless (@_) {
         return undef;
@@ -508,7 +509,7 @@
 
     foreach $el (@_)
     {
-        if (ref($el) eq ARRAY) {
+        if (ref($el) eq "ARRAY") {
             $data .= emit_group(@$el);
         } else {
             if (($el !~ m/^[\\\;\{\}]/) and (substr($data, length($data)-1) !~ m/[\}\{\s]/)) {
@@ -548,7 +549,7 @@
     my $self = shift;
 
     my $name = shift,
-       $attributes = shift;
+    my $attributes = shift;
 
     my $class = $FONTCLASSES{${$attributes}{family}};
 
@@ -580,7 +581,8 @@
 
     $self->add_raw ($fattr, escape_simple($name) );
 
-    my @alternates = @{${$attributes}{alternates}};
+    my @alternates = ();
+       @alternates = @{${$attributes}{alternates}} if ( defined @{${$attributes}{alternates}} );
     if (@alternates) {
         while ($_ = shift @alternates) {
             $self->add_raw ($fattr, [ '\*\falt '.escape_simple($_) ] );
@@ -630,7 +632,7 @@
         $self->add_raw ( $self->{styletbl}, '\stylesheet');
     }
 
-    $type = ${$attributes}{type} || "paragraph";
+    my $type = ${$attributes}{type} || "paragraph";
     my $code = $STYLETYPES{$type};
     unless (defined($code)) {
         carp "Don\'t know how to handle a \`$type\' style";
@@ -654,7 +656,7 @@
         if (defined(${$attributes}{next}));
 
     my $sbasedon = ${$attributes}{basedon} || "none",
-       $snext    = ${$attributes}{next}    || "self";
+    my $snext    = ${$attributes}{next}    || "self";
 
     $sbasedon = decode_stylename($sbasedon, $style);
     $snext    = decode_stylename($snext, $style);
@@ -802,7 +804,7 @@
     my $position = shift;
     my $length = shift;
 
-    splice @{$section}, $position, $length, @_;
+    splice @{$section}, $position, $length, @_ ;
 }
 
 sub add_raw # add a raw value to a section
@@ -855,16 +857,16 @@
 
     while ($arg = shift) {
         $rarg = ref($arg);
-        if ($rarg eq HASH)
+        if ($rarg eq "HASH")
         {
             $self->set_properties (\%PROPERTIES, $arg, $group);
         }
-        elsif ($rarg eq ARRAY)
+        elsif ($rarg eq "ARRAY")
         {
             my $subgroup = $self->add_group($group);
             $self->add_text ($subgroup, @{$arg} );
         }
-        elsif ($rarg eq SCALAR)
+        elsif ($rarg eq "SCALAR")
         {
             $self->add_text (${$arg});
         }
@@ -1192,5 +1194,9 @@
 This program is free software; you can redistribute it and/or
 modify it under the same terms as Perl itself.
 
-=cut
+=head1 FIXES
 
+Some bugs have been fixed by nmag only <nmag@softhome.net>, now
+the code is clean and under strict directives.
+
+=cut
